dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

last_speeds_squared = last_speeds_squared or {}
prev_x = prev_x or x
prev_y = prev_y or y

local avg_speed_squared = 0

for i, v in ipairs(last_speeds_squared) do
  avg_speed_squared = avg_speed_squared + v
end
avg_speed_squared = avg_speed_squared / #last_speeds_squared

local vx = x - prev_x
local vy = y - prev_y

table.insert(last_speeds_squared, vx^2 + vy^2)
if #last_speeds_squared > 5 then
  table.remove(last_speeds_squared, 1)
  
  local found_normal, normal_x, normal_y, approximate_distance_from_surface = GetSurfaceNormal(x, y, 2, 8)
  local something_in_front = found_normal
  if avg_speed_squared < 0.2 and something_in_front then
    EntityKill(entity_id)
  end
end

prev_x = x
prev_y = y
