local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local state = get_state()

state.tick = (state.tick or 4) - 1

if state.tick <= 0 then  
  local projectile_entity = EntityGetWithName("player_projectile_entity")
  local projectile_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "ProjectileComponent")
  EntitySetComponentIsEnabled(entity_id, projectile_component, true)
  EntitySetComponentsWithTagEnabled(entity_id, "die_on_collision", 1)
  EntityRemoveComponent(entity_id, GetUpdatedComponentID())
else
  GamePrint("Collision immunity ends in " .. state.tick .. "...")
end
