dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity_id)
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  local projectile_component = EntityGetFirstComponent(entity_id, "ProjectileComponent")
  if GlobalsGetValue("mmm_teleport_start_x", "") == "" then
    GlobalsSetValue("mmm_teleport_start_x", x)
    GlobalsSetValue("mmm_teleport_start_y", y)
    -- Make player not explode by accident while being teleported
    local projectile_entity = EntityGetWithName("player_projectile_entity")
    local projectile_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "ProjectileComponent")
    EntitySetComponentIsEnabled(entity_id, projectile_component, false)
    EntitySetComponentsWithTagEnabled(entity_id, "die_on_collision", 0)
  end
end
